<template>
  <div class="download-container">
    <div v-if="!error">
      <div class="loader" :class="{'hidden': started}"></div>
      <div class="download-title">Сейчас начнется загрузка файла</div>
      <div class="download-sub">
        Если загрузка не началась, нажмите <span @click="downloadFile">здесь</span>.
      </div>
    </div>

    <div v-else>
      <div class="download-title">Упс, произошла ошибка</div>
      <div class="download-sub">{{ errorTitle }}</div>
    </div>
  </div>
</template>

<script>
  import api from '@/api'

  export default {
    name: 'DownloadStorageFile',
    components: {

    },
    computed: {
      errorTitle: ({ error }) => {
        let text = '';

        switch (error.status) {
          case 404:
            text = 'Запрашиваемый файл не найден'
            break;
        }

        return text;
      }
    },
    created() {
      this.downloadFile();
    },
    data() {
      return {
        started: false,
        error: null
      }
    },
    methods: {


      async downloadFile() {

        try {
          const response = await api.files.getFile(this.$route.params.id);

          const { name, data } = response;

          const url = window.URL.createObjectURL(new Blob([data]));
          const link = document.createElement('a');
          link.href = url;
          link.setAttribute('download', name);
          document.body.appendChild(link);
          link.click();
          document.body.removeChild(link);

        } catch(e) {
          this.error = e;
        }

        this.started = true;
      },
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .download-container {
    width: 100%;
    height: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    text-align: center;
  }

  .download-title {
    @include font-mixin(28px, 36px, 400);
    text-align: center;
    margin-bottom: 10px;
    margin-top: 20px;
  }

  .download-sub {
    @include font-mixin(14px, 20px, 400, inherit, 0.4px);

    span {
      color: $color-blue-navy-blue;
      text-decoration: underline;
      cursor: pointer;
    }
  }



  .loader {
    position: relative;
    display: block;
    margin: 0 auto;
    width: 72px;
    height: 72px;
    border-radius: 50%;
    border: 3px solid transparent;
    border-top-color: $deep-blue;
    -webkit-animation: spin 2s linear infinite;
    animation: spin 2s linear infinite;
    transition: opacity 1s ease-out;
    will-change: opacity;

    &.hidden {
      opacity: 0;
    }

    &::before {
      content: "";
      position: absolute;
      top: 5px;
      left: 5px;
      right: 5px;
      bottom: 5px;
      border-radius: 50%;
      border: 3px solid transparent;
      border-top-color: $green-800;
      -webkit-animation: spin 3s linear infinite;
      animation: spin 3s linear infinite;
    }

    &::after {
      content: "";
      position: absolute;
      top: 15px;
      left: 15px;
      right: 15px;
      bottom: 15px;
      border-radius: 50%;
      border: 3px solid transparent;
      border-top-color: $Green-600;
      -webkit-animation: spin 1.5s linear infinite;
      animation: spin 1.5s linear infinite;
    }
  }

  @-webkit-keyframes spin {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }

  @keyframes spin {
    0% {
      transform: rotate(0deg);
    }
    100% {
      transform: rotate(360deg);
    }
  }

</style>